#!/usr/bin/env python

from sss import ssslib
from string import split, join
import sys
import re
from elementtree.ElementTree import Element, SubElement, XML, tostring

def usage():
    print """Usage:
bs-client.py get -r restrictions
 or
bs-client.py set key=value -r restrictions
 or
bs-client.py del -r restrictions
 or
bs-client.py add values"""
    sys.exit(1)

getargre = re.compile("^(-d ){0,1}get -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
setargre = re.compile("^(-d ){0,1}set (?P<update>\S+=\S+) -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
addargre = re.compile("^(-d ){0,1}add (?P<values>(\S+=\S+ {0,1})+)$")
delargre = re.compile("^(-d ){0,1}del -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
argstring = join(sys.argv[1:]," ")

if getargre.match(argstring):
    restrictions = getargre.match(argstring).group("restrictions")
    req = Element("get-node-software")
    ns = SubElement(req, "node-software")
    for el in ['node','image','kernel','class','mayor','action','kernel_opts']:
        SubElement(ns, el)
        ns.find(el).attrib['match'] = 'false'
    for rest in split(restrictions):
        if ns.find(split(rest,"=")[0]) == None:
            SubElement(ns, split(rest,"=")[0])
        if split(rest,"=")[1] == '*':
            ns.find(split(rest,"=")[0]).attrib['match'] = 'false'
        else:
            ns.find(split(rest,"=")[0]).text = split(rest,"=")[1]
            ns.find(split(rest,"=")[0]).attrib['match'] = 'true'
    action = "get"
elif setargre.match(argstring):
    restrictions = setargre.match(argstring).group("restrictions")
    update = setargre.match(argstring).group("update")
    req = Element("set-node-software")
    ns = SubElement(req, "node-software")
    for el in ['node','image','kernel','class','mayor','action','kernel_opts']:
        SubElement(ns, el)
        ns.find(el).attrib['match'] = 'false'
    for rest in split(restrictions):
        if ns.find(split(rest,"=")[0]) == None:
            SubElement(ns, split(rest,"=")[0])
        if split(rest,"=")[1] == '*':
            ns.find(split(rest,"=")[0]).attrib['match'] = 'false'
        else:
            ns.find(split(rest,"=")[0]).text = split(rest,"=")[1]
            ns.find(split(rest,"=")[0]).attrib['match'] = 'true'
    SubElement(req, split(update,"=")[0])
    req.find(split(update,"=")[0]).text = split(update,"=")[1]
    action = "set"
elif addargre.match(argstring):
    values = addargre.match(argstring).group("values")
    req = Element("add-node-software")
    ns = SubElement(req, "node-software")
    for value in split(values):
        if ns.find(split(value,"=")[0]) == None:
            SubElement(ns, split(value,"=")[0])
        ns.find(split(value,"=")[0]).text = split(value,"=")[1]
    action = "add"
elif delargre.match(argstring):
    restrictions = delargre.match(argstring).group("restrictions")
    req = Element("del-node-software")
    ns = SubElement(req, "node-software")
    for el in ['node','image','kernel','class','mayor','action','kernel_opts']:
        SubElement(ns, el)
        ns.find(el).attrib['match'] = 'false'
    for rest in split(restrictions):
        if ns.find(split(rest,"=")[0]) == None:
            SubElement(ns, split(rest,"=")[0])
        if split(rest,"=")[1] == '*':
            ns.find(split(rest,"=")[0]).attrib['match'] = 'false'
        else:
            ns.find(split(rest,"=")[0]).text = split(rest,"=")[1]
            ns.find(split(rest,"=")[0]).attrib['match'] = 'true'
    action = "del"
else:
    usage()

sss = ssslib.comm_lib(debug=('-d' in sys.argv))
handle = sss.ClientInit("build-system")
sss.SendMessage(handle,tostring(req))
msg = sss.RecvMessage(handle)
sss.ClientClose(handle)
del sss
try:
    domobj = XML(msg)
except:
    print "server error"
    exit(1)

if domobj.findall("node-software") != []:
    fields = [el.tag for el in domobj.find("node-software")]
    results=[tuple(fields)]
    for record in domobj.findall("node-software"):
        results.append(tuple(map(lambda x:record.find(x).text, fields)))
    lendata=map(lambda x:map(len,x),results)
    fsizes=tuple(map(lambda i:apply(max,map(lambda x:x[i],lendata)),range(len(lendata[0]))))
    fstring="%%%ss   %%%ss   %%%ss   %%%ss   %%%ss   %%%ss   %%%ss"%fsizes
    i=0
    for data in results:
        print fstring%data
        if not i:
            print "================================================================================"
            i=1
